﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MasterProcess {
	public partial class Form1 : Form {
		Process process;

		public Form1() {
			InitializeComponent();
		}

		// log one line of text in the ListBox (taking care of thread crossing)
		private void log(string s) {
			if (lb.InvokeRequired) {
				lb.Invoke(new Action<string>(log), s);
			} else {
				if (s.Length!=0) s=DateTime.Now.ToString("HH:mm:ss.fff  ")+s;
				lb.Items.Add(s);
				lb.TopIndex=lb.Items.Count-1;
			}
		}

		private void btnStart_Click(object sender, EventArgs e) {
			log("");
			log("start");
			process=new Process();
			process.EnableRaisingEvents=true;
			process.Exited+=new EventHandler(process_Exited);
			process.StartInfo.FileName="SlaveProcess.exe";
			process.StartInfo.Arguments=tbCommand.Text;
			process.StartInfo.UseShellExecute=false;
			process.StartInfo.RedirectStandardOutput=true;
			process.StartInfo.RedirectStandardError=true;
			process.Start();
			process.ErrorDataReceived+=new DataReceivedEventHandler(process_ErrorDataReceived);
			process.OutputDataReceived+=new DataReceivedEventHandler(process_OutputDataReceived);
			process.BeginOutputReadLine();
			process.BeginErrorReadLine();
			log("launched");
		}

		void process_Exited(object sender, EventArgs e) {
			log("exited");
		}

		void process_OutputDataReceived(object sender, DataReceivedEventArgs e) {
			string s=e.Data;
			log("OutputDataReceived: "+s);
		}

		void process_ErrorDataReceived(object sender, DataReceivedEventArgs e) {
			string s=e.Data;
			log("ErrorDataReceived:  "+s);
		}
	}
}
