﻿using System;
using System.Threading;

namespace SlaveProcess {
	static class SlaveProcess {
		[STAThread]
		static void Main() {
			bool autowait=false;
			string[] args=Environment.GetCommandLineArgs();
			if (args.Length!=2) {
				Out("Expecting one command line argument, a string, where each char causes one action:");
				Out("O=output a line, E=Output an error line, 1=wait 1 second, A=always wait 1 second");
			} else {
				string commands=args[1];
				Out("commands="+commands);
				int charcount=0;
				foreach(char c in commands) {
					charcount++;
					string time=DateTime.Now.ToString("HH:mm:ss.fff ");
					switch (c) {
						case 'A':
							Out("A"+charcount.ToString("00")+": "+time);
							autowait=true;
							break;
						case '1':
							Thread.Sleep(1000);
							break;
						case 'O':
							System.Console.Out.WriteLine("O"+charcount.ToString("00")+": "+time);
							if (autowait) Thread.Sleep(1000);
							break;
						case 'E':
							System.Console.Error.WriteLine("E"+charcount.ToString("00")+": "+time);
							if (autowait) Thread.Sleep(1000);
							break;
						default:
							Out("Bad command: "+c);
							break;
					}
				}
				Out("Done");
			}
		}

		// while intended for logging (it logs to the Console when running within Visual Studio),
		// this method will send the message to the standard output stream, hence it may get
		// redirected by the master process.
		private static void Out(string s) {
			Console.WriteLine(s);
		}
	}
}
